//+------------------------------------------------------------------+
//|                                                      [e]Gann.mq4 |
//|                                      Copyright  2008, komposter |
//|                                      mailto:komposterius@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, komposter"
#property link      "mailto:komposterius@mail.ru"

/*
          ,       .

   :
    (        sell,  ,      -  
  buy)      !!!  ! !,      .
     .

      (  -       sell   ! - 
    ,     .)
         -    (    ).

      . 
          -        BreakEvenAfter,
           BreakEvenTo  .

       -  ,        ,     
    .

              -      
   1999     3,       -     .

 ,    .
*/

//----   (    ) -     
extern string 		Expert_Properties 			= "-------Expert-Properties-------";
extern int 			Expert_Id 						= 1244;	//   .   2-         2 ,     Expert_Id
extern bool 		AllowTrade 						= true;	// true -   , false - 
extern bool 		AllowAlert 						= false;	// true -      , false - 
extern double		Lot								= 0.1;	//    MeansType = 0
extern double		Risk								= 0.0;	// %    ( MeansType > 0)
extern int			MeansType						= 0;		// ,     (0 -   (Lot), 1 - Risk %  Balance, 2 - Risk %  Equity, 3 - Risk %  FreeMargin)
extern double		AfterStopLoss_Koeff			= 0.0;	//  AfterStopLoss_Koeff > 0,          "   * AfterStopLoss_Koeff"
extern int			StopLoss							= 0;		//      (0 -   , -1 -  )
extern int			TakeProfit						= 0;		//      (0 -  )
extern int			BreakEvenAfter					= 25;		//    BreakEvenAfter ...
extern int			BreakEvenTo						= 0;		// ...    "  + BreakEvenTo " ( BreakEvenAfter = 0,   )
extern int			TrailingStop					= 0;		//     (0 -  )
extern int			TrailingStep					= 5;		//    

extern string 		Indicator_Properties 		= "------Indicator-Properties-----";
extern int			R									= 48;
extern int			pips								= 0;
extern int			shifft							= 1;

#include <trade_lib&info_lib.mqh>

int signal = 0, counted_bar = 0, last_trade = 0;
double sl_b, sl_s;

int init()
{
	TradeInfoLib_Initialization ( Expert_Id, "[e]Gann" );
	return(0);
}

int deinit()
{
	TradeInfoLib_Deinitialization();
	return(0);
}

int start()
{
	if ( !IsOK() ) { return(0); }

	find_signal();

	if ( !_IsExpertOrder ( _MagicNumber ) )
		trade();
	else
		trade_control();

	return(0);
}

void find_signal()
{
	if ( Time[0] <= counted_bar ) { return(0); }
	counted_bar = Time[0];

	signal = 0;

	//     (        sell,  ,      -  
	//   buy)      !!!  ! !,      .
	double b1 = iCustom( NULL, 0, "Gann", R, pips, shifft, true, false, 2000, 0, 0 );
	double s1 = iCustom( NULL, 0, "Gann", R, pips, shifft, true, false, 2000, 1, 0 );
	double b2 = iCustom( NULL, 0, "Gann", R, pips, shifft, true, false, 2000, 0, 1 );
	double s2 = iCustom( NULL, 0, "Gann", R, pips, shifft, true, false, 2000, 1, 1 );

	if ( b1 > _Point/2 && b2 < _Point && s1 < _Point && s2 > _Point/2 && s2 >= Low[1] && s2 <= High[1] ) signal =  1;
	if ( s1 > _Point/2 && s2 < _Point && b1 < _Point && b2 > _Point/2 && b2 >= Low[1] && b2 <= High[1] ) signal = -1;

	//       (  -       sell   ! - 
	//     ,     .)
	//          -    (    ).
	if ( signal != 0 )
	{
		if ( StopLoss > 0 )
		{
			sl_b = NormalizeDouble( Ask - StopLoss*_Point, _Digits );
			sl_s = NormalizeDouble( Bid + StopLoss*_Point, _Digits );
		}
		else
		{
			if ( StopLoss == 0 )
			{
				sl_b = NormalizeDouble( b1/*iCustom( NULL, 0, "Gann", R, pips, shifft, true, false, 2000, 0, 0 )*/, _Digits );
				if ( NormalizeDouble( Bid - sl_b - _StopLevel, _Digits ) <= 0.0 ) sl_b = NormalizeDouble( Bid - _StopLevel, _Digits );
				sl_s = NormalizeDouble( s1/*iCustom( NULL, 0, "Gann", R, pips, shifft, true, false, 2000, 1, 0 )*/, _Digits );
				if ( NormalizeDouble( sl_s - Ask - _StopLevel, _Digits ) <= 0.0 ) sl_s = NormalizeDouble( Ask + _StopLevel, _Digits );
			}
			else
			{
				sl_b = 0.0;
				sl_s = 0.0;
			}
		}
	}
}

//+------------------------------------------------------------------+
//| -                                                    |
//+------------------------------------------------------------------+
void trade()
{
	if ( signal > 0 ) { OpenBuy (); return; }
	if ( signal < 0 ) { OpenSell(); return; }
}

//+------------------------------------------------------------------+
//| -                                     |
//+------------------------------------------------------------------+
void trade_control()
{
	_ExpertOrdersInit( _MagicNumber );

	//           -        ProfitLevel,
	//            CloseLvel  .
	if ( _BuyTicket > 0 )
	{
		if ( signal < 0 )
		{
			if ( _OrderClose( _BuyTicket ) > 0 ) OpenSell();
			return;
		}
		if ( BreakEvenAfter > 0 && BreakEvenTo >= 0 )
		{
			if ( NormalizeDouble( Bid - _BuyOpenPrice - BreakEvenAfter*_Point, _Digits ) >= 0.0 )
			{
				if ( NormalizeDouble( (_BuyOpenPrice + BreakEvenTo*_Point) - _BuyStopLoss, _Digits ) > 0.0 || _BuyStopLoss < _Point )
				{
					_OrderModify( _BuyTicket, -1, _BuyOpenPrice + BreakEvenTo*_Point, -1 );
				}
			}
		}
		_TrailingStop( _BuyTicket, TrailingStop, 0, TrailingStep );
	}
	if ( _SellTicket > 0 )
	{
		if ( signal > 0 )
		{
			if ( _OrderClose( _SellTicket ) > 0 ) OpenBuy ();
			return;
		}
		if ( BreakEvenAfter > 0 && BreakEvenTo >= 0 )
		{
			if ( NormalizeDouble( _SellOpenPrice - Ask - BreakEvenAfter*_Point, _Digits ) >= 0.0 )
			{
				if ( NormalizeDouble( _SellStopLoss - (_SellOpenPrice - BreakEvenTo*_Point), _Digits ) > 0.0 || _SellStopLoss < _Point )
				{
					_OrderModify( _SellTicket, -1, _SellOpenPrice - BreakEvenTo*_Point, -1 );
				}
			}
		}
		_TrailingStop( _SellTicket, TrailingStop, 0, TrailingStep );
	}
}

void OpenBuy()
{
	if ( Time[0] <= last_trade ) return(0);

	if ( AllowAlert ) Alert( strComment, ": BUY-signal!" );
	if ( !AllowTrade )
	{
		last_trade = Time[0];
		return;
	}

	double useLot = LotSize();
	if ( useLot < 0.0001 )
	{
		last_trade = Time[0];
		return;
	}

	double _OpenPriceLevel, _StopLossLevel, _TakeProfitLevel;
	_OpenPriceLevel = NormalizeDouble( Ask, _Digits );

	_StopLossLevel = sl_b;

	if ( TakeProfit > 0 )
	{ _TakeProfitLevel = NormalizeDouble( _OpenPriceLevel + TakeProfit*_Point, _Digits ); }
	else
	{ _TakeProfitLevel = 0.0; }

	if ( _OrderSend ( _Symbol, OP_BUY, useLot, _OpenPriceLevel, Slippage, _StopLossLevel, _TakeProfitLevel, "", _MagicNumber ) > 0 )
		last_trade = Time[0];
	else
		Alert( strComment, ":    BUY-!!!" );
}

void OpenSell()
{
	if ( Time[0] <= last_trade ) return(0);

	if ( AllowAlert ) Alert( strComment, ": BUY-signal!" );
	if ( !AllowTrade )
	{
		last_trade = Time[0];
		return;
	}

	double useLot = LotSize();
	if ( useLot < 0.0001 )
	{
		last_trade = Time[0];
		return;
	}

	double _OpenPriceLevel, _StopLossLevel, _TakeProfitLevel;
	_OpenPriceLevel = NormalizeDouble( Bid, _Digits );

	_StopLossLevel = sl_s;

	if ( TakeProfit > 0 )
	{ _TakeProfitLevel = NormalizeDouble( _OpenPriceLevel - TakeProfit*_Point, _Digits ); }
	else
	{ _TakeProfitLevel = 0.0; }

	if ( _OrderSend ( _Symbol, OP_SELL, useLot, _OpenPriceLevel, Slippage, _StopLossLevel, _TakeProfitLevel, "", _MagicNumber ) > 0 )
		last_trade = Time[0];
	else
		Alert( strComment, ":    SELL-!!!" );
}

double LotSize()
{
	double	lot			= Lot;
	double 	lot_min		= MarketInfo( _Symbol, MODE_MINLOT  );
	double 	lot_max		= MarketInfo( _Symbol, MODE_MAXLOT  );
	double 	lot_step		= MarketInfo( _Symbol, MODE_LOTSTEP );

	double lastLot = 0.0;
	if ( AfterStopLoss_Koeff > 0.0 ) lastLot = lastLossLot();

	if ( lastLot < 0.0001 )
	{
		int 		lot_size		= MarketInfo( _Symbol, MODE_LOTSIZE );
		double 	balance		= AccountBalance();
		int		leverage		= AccountLeverage();

		if ( MeansType == 2 ) balance = AccountEquity();
		if ( MeansType == 3 ) balance = AccountFreeMargin();

		if ( lot_min < 0 || lot_max <= 0.0 || lot_step <= 0.0 || lot_size <= 0 ) 
		{
			Print( "LotSize: invalid MarketInfo() results [" + lot_min + "," + lot_max + "," + lot_step + "," + lot_size + "]" );
			return(-1);
		}
		if ( leverage <= 0 )
		{
			Print( "LotSize: invalid AccountLeverage() [" + leverage + "]" );
			return(-1);
		}

		if ( MeansType > 0 ) lot = balance * Risk*0.01 * leverage / lot_size;
	}
	else
	{
		lot = MathCeil( lastLot * AfterStopLoss_Koeff / lot_step ) * lot_step;
	}

	lot = NormalizeDouble( lot / lot_step, 0 ) * lot_step;
	if ( lot < lot_min ) lot = lot_min;
	if ( lot > lot_max ) lot = lot_max;

	if ( AccountFreeMarginCheck( _Symbol, OP_BUY, lot ) < 10 || GetLastError() == 134 )
	{
		Alert( "       ", DoubleToStr( lot, 2 ), " lots!" );
		last_trade = Time[0];
		return(-1);
	}

	return(lot);
}

double lastLossLot()
{
	int total = OrdersHistoryTotal(), last_op = 0; double last_profit = 0.0, last_lot = 0.0;
	for ( int z = total-1; z >= 0; z -- )
	{
		if ( !OrderSelect( z, SELECT_BY_POS, MODE_HISTORY ) )
		{
			int _GetLastError = GetLastError();
			Print( "OrderSelect( ", z, ", SELECT_BY_POS, MODE_HISTORY ) - Error #", _GetLastError, " ( ", ErrorDescription( _GetLastError ), " )" );
			continue;
		}
		if ( OrderSymbol() != _Symbol ) continue;
		if ( OrderMagicNumber() != _MagicNumber ) continue;

		if ( OrderOpenTime() > last_op )
		{
			last_op = OrderOpenTime();
			last_profit = OrderProfit();
			last_lot = OrderLots();
		}
	}

	if ( last_profit > 0.0 )
		return(0.0);
	else
		return(last_lot);
}